# Ngx-EditorJS Plugins

This module provides a default set of [EditorJS](https://editorjs.io) plugins for [@tinynodes/ngx-editorjs](https://www.npmjs.com/package/@tinynodes/ngx-editorjs) via Angular modules and also provides the plugin service for registering and providing these plugins.

## Plugin Service

This package includes the `NgxEditorJSPluginService` which provides a singleton for registering
EditorJS plugins with.

## Plugin List

| Plugin Name             | Description                                            | EditorJS Plugin Link                             |
| ----------------------- | ------------------------------------------------------ | ------------------------------------------------ |
| PluginCodeModule        | Provides a `<code>` block editor                       | [GitHub](https://github.com/editor-js/code)      |
| PluginHeaderModule      | Provides a `<h1> - <h6>` block editor                  | [GitHub](https://github.com/editor-js/header)    |
| PluginImageModule       | Provides an `<img>` block editor + file upload support | [GitHub](https://github.com/editor-js/image)     |
| PluginLinkModule        | Provides an `<a>` block editor                         | [GitHub](https://github.com/editor-js/link)      |
| PluginIListModule       | Provides an `<ol>/<li>` block editor                   | [GitHub](https://github.com/editor-js/list)      |
| PluginMarkerModule      | Provides inline text marking                           | [GitHub](https://github.com/editor-js/marker)    |
| PluginParagraphModule   | Provides an `<p>` block editor                         | [GitHub](https://github.com/editor-js/paragraph) |
| PluginSimpleImageModule | Provides an `<img>` block editor with paste support    | [GitHub](https://github.com/editor-js/paragraph) |
