import { CommonModule } from '@angular/common';
import Code from '@editorjs/code';
import Header from '@editorjs/header';
import Image from '@editorjs/image';
import Link from '@editorjs/link';
import List from '@editorjs/list';
import Marker from '@editorjs/marker';
import Paragraph from '@editorjs/paragraph';
import SimpleImage from '@editorjs/simple-image';
import { Injectable, NgModule, InjectionToken, Inject, Optional, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<code>` block tool for `EditorJS`
 */
class PluginCode {
    /**
     * Returns the `ToolSettings` for this plugin
     * @return {?}
     */
    plugin() {
        return Code;
    }
}
PluginCode.decorators = [
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<code>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/code) for API details
 */
class PluginCodeModule {
}
PluginCodeModule.decorators = [
    { type: NgModule, args: [{
                providers: [PluginCode]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<h1> - <h6>` block tool for `EditorJS`
 */
class PluginHeader {
    /**
     * Returns the plugin settings
     * @return {?}
     */
    plugin() {
        return Header;
    }
}
PluginHeader.decorators = [
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` header block tool.
 * See [the GitHub repo](https://github.com/editor-js/header) for API details
 */
class PluginHeaderModule {
}
PluginHeaderModule.decorators = [
    { type: NgModule, args: [{
                providers: [PluginHeader]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<h1> - <h6>` block tool for `EditorJS`
 */
class PluginImage {
    /**
     * Returns the plugin settings
     * @return {?}
     */
    plugin() {
        return Image;
    }
}
PluginImage.decorators = [
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<img>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/image) for API details
 */
class PluginImageModule {
}
PluginImageModule.decorators = [
    { type: NgModule, args: [{
                providers: [PluginImage]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<a>` block tool for `EditorJS`
 */
class PluginLink {
    /**
     * Returns the plugin settings
     * @return {?}
     */
    plugin() {
        return Link;
    }
}
PluginLink.decorators = [
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<a>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/link) for API details
 */
class PluginLinkModule {
}
PluginLinkModule.decorators = [
    { type: NgModule, args: [{
                providers: [PluginLink]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<li>` and `<ol>` block tool for `EditorJS`
 */
class PluginList {
    /**
     * Returns the plugin settings
     * @return {?}
     */
    plugin() {
        return List;
    }
}
PluginList.decorators = [
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<li>` and `<ol>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/list) for API details
 */
class PluginListModule {
}
PluginListModule.decorators = [
    { type: NgModule, args: [{
                providers: [PluginList]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a inline marker tool for `EditorJS`
 */
class PluginMarker {
    /**
     * Returns the plugin settings
     * @return {?}
     */
    plugin() {
        return Marker;
    }
    /**
     * Returns the plugin shortcut
     * @return {?}
     */
    shortcut() {
        return 'CMD+SHIFT+M';
    }
}
PluginMarker.decorators = [
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` inline marker tool.
 * See [the GitHub repo](https://github.com/editor-js/marker) for API details
 */
class PluginMarkerModule {
}
PluginMarkerModule.decorators = [
    { type: NgModule, args: [{
                providers: [PluginMarker]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<p>` block tool for `EditorJS`
 */
class PluginParagraph {
    /**
     * Returns the plugin settings
     * @return {?}
     */
    plugin() {
        return Paragraph;
    }
}
PluginParagraph.decorators = [
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<p>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
 */
class PluginParagraphModule {
}
PluginParagraphModule.decorators = [
    { type: NgModule, args: [{
                providers: [PluginParagraph]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the simple image tool for `<img>` block editor `EditorJS`
 */
class PluginSimpleImage {
    /**
     * Returns the plugin settings
     * @return {?}
     */
    plugin() {
        return SimpleImage;
    }
}
PluginSimpleImage.decorators = [
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the simple image tools for `EditorJS` `<img>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/image) for API details
 */
class PluginSimpleImageModule {
}
PluginSimpleImageModule.decorators = [
    { type: NgModule, args: [{
                providers: [PluginSimpleImage]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * The Injection token for initial plugins as defined in the ngx-editorjs module
 * @type {?}
 */
const InitialPlugins = new InjectionToken('InitialPlugins');
/**
 * The injection token for adding plugins via your own application
 * @type {?}
 */
const UserPlugins = new InjectionToken('UserPlugins');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * The plugin service provides a singleton to store all plugins injected into the application
 * and makes them available for all instances of `EditorJS`
 */
class NgxEditorJSPluginService {
    /**
     * When the class is initialized the initial plugins and any user plugins
     * will be passed in and merged and stored in the config map
     * @param {?} initialPlugins Default plugins produced by the module
     * @param {?} userPlugins User plugins injected into the application
     */
    constructor(initialPlugins, userPlugins) {
        /**
         * Object map of the plugin configurations
         */
        this.pluginsMap = {};
        Object.entries(Object.assign({}, initialPlugins, userPlugins)).forEach((/**
         * @param {?} __0
         * @return {?}
         */
        ([key, tool]) => this.add(key, tool)));
    }
    /**
     * Add a plugin to the store
     * @param {?} key The key for the map to store the plugin
     * @param {?} plugin The plugin instance to add to the service
     * @return {?}
     */
    add(key, plugin) {
        this.pluginsMap[key] = plugin;
    }
    /**
     * Remove a plugin from the store
     * @param {?} key
     * @return {?}
     */
    remove(key) {
        this.pluginsMap[key] = null;
        delete this.pluginsMap[key];
    }
    /**
     * Get a single plugin from the map
     * @param {?} key
     * @return {?}
     */
    get(key) {
        return this.pluginsMap[key];
    }
    /**
     * Returns a map of all the plugins registered with this service
     * @return {?}
     */
    get plugins() {
        return this.pluginsMap;
    }
    /**
     * Returns a map of tools to be initialized by the editor
     * @param {?=} exclude Optional array of keys to exclude from the map
     * @return {?}
     */
    getTools(exclude = []) {
        return Object.entries(this.pluginsMap)
            .filter((/**
         * @param {?} __0
         * @return {?}
         */
        ([key]) => {
            return !exclude.includes(key);
        }))
            .reduce((/**
         * @param {?} finalTools
         * @param {?} __1
         * @return {?}
         */
        (finalTools, [key, plugin]) => {
            if (plugin.shortcut) {
                return Object.assign({ [key]: {
                        class: plugin.plugin(),
                        shortcut: plugin.shortcut()
                    } }, finalTools);
            }
            else {
                return Object.assign({ [key]: plugin.plugin() }, finalTools);
            }
        }), {});
    }
}
NgxEditorJSPluginService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxEditorJSPluginService.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [InitialPlugins,] }] },
    { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [UserPlugins,] }] }
];
/** @nocollapse */ NgxEditorJSPluginService.ngInjectableDef = defineInjectable({ factory: function NgxEditorJSPluginService_Factory() { return new NgxEditorJSPluginService(inject(InitialPlugins), inject(UserPlugins, 8)); }, token: NgxEditorJSPluginService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This module provides the plugin service used by NgxEditorJS.
 */
class NgxEditorJSPluginServiceModule {
}
NgxEditorJSPluginServiceModule.decorators = [
    { type: NgModule, args: [{
                providers: [NgxEditorJSPluginService]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * The `NgxEditorjsPluginsModule` provides several additional modules
 * that provide a way to easily plug in block and inline tools for `EditorJS`.
 *
 * Importing `NgxEditorjsPluginsModule` will include all modules, while it
 * is also possible to import each individual module as required.
 */
class NgxEditorjsPluginsModule {
}
NgxEditorjsPluginsModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    PluginCodeModule,
                    PluginHeaderModule,
                    PluginImageModule,
                    PluginLinkModule,
                    PluginListModule,
                    PluginMarkerModule,
                    PluginParagraphModule,
                    PluginSimpleImageModule,
                    NgxEditorJSPluginServiceModule
                ],
                exports: [
                    PluginCodeModule,
                    PluginHeaderModule,
                    PluginImageModule,
                    PluginLinkModule,
                    PluginListModule,
                    PluginMarkerModule,
                    PluginParagraphModule,
                    PluginSimpleImageModule,
                    NgxEditorJSPluginServiceModule
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxEditorjsPluginsModule, PluginCodeModule, PluginCode, PluginHeaderModule, PluginHeader, PluginImageModule, PluginImage, PluginLinkModule, PluginLink, PluginListModule, PluginList, PluginMarkerModule, PluginMarker, PluginParagraphModule, PluginParagraph, PluginSimpleImageModule, PluginSimpleImage, NgxEditorJSPluginService, InitialPlugins, UserPlugins, NgxEditorJSPluginServiceModule as ɵa };

//# sourceMappingURL=tinynodes-ngx-editorjs-plugins.js.map