import { CommonModule } from '@angular/common';
import Code from '@editorjs/code';
import Header from '@editorjs/header';
import Image from '@editorjs/image';
import Link from '@editorjs/link';
import List from '@editorjs/list';
import Marker from '@editorjs/marker';
import Paragraph from '@editorjs/paragraph';
import SimpleImage from '@editorjs/simple-image';
import { __assign, __read } from 'tslib';
import { Injectable, NgModule, InjectionToken, Inject, Optional, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<code>` block tool for `EditorJS`
 */
var PluginCode = /** @class */ (function () {
    function PluginCode() {
    }
    /**
     * Returns the `ToolSettings` for this plugin
     */
    /**
     * Returns the `ToolSettings` for this plugin
     * @return {?}
     */
    PluginCode.prototype.plugin = /**
     * Returns the `ToolSettings` for this plugin
     * @return {?}
     */
    function () {
        return Code;
    };
    PluginCode.decorators = [
        { type: Injectable }
    ];
    return PluginCode;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<code>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/code) for API details
 */
var PluginCodeModule = /** @class */ (function () {
    function PluginCodeModule() {
    }
    PluginCodeModule.decorators = [
        { type: NgModule, args: [{
                    providers: [PluginCode]
                },] }
    ];
    return PluginCodeModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<h1> - <h6>` block tool for `EditorJS`
 */
var PluginHeader = /** @class */ (function () {
    function PluginHeader() {
    }
    /**
     * Returns the plugin settings
     */
    /**
     * Returns the plugin settings
     * @return {?}
     */
    PluginHeader.prototype.plugin = /**
     * Returns the plugin settings
     * @return {?}
     */
    function () {
        return Header;
    };
    PluginHeader.decorators = [
        { type: Injectable }
    ];
    return PluginHeader;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` header block tool.
 * See [the GitHub repo](https://github.com/editor-js/header) for API details
 */
var PluginHeaderModule = /** @class */ (function () {
    function PluginHeaderModule() {
    }
    PluginHeaderModule.decorators = [
        { type: NgModule, args: [{
                    providers: [PluginHeader]
                },] }
    ];
    return PluginHeaderModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<h1> - <h6>` block tool for `EditorJS`
 */
var PluginImage = /** @class */ (function () {
    function PluginImage() {
    }
    /**
     * Returns the plugin settings
     */
    /**
     * Returns the plugin settings
     * @return {?}
     */
    PluginImage.prototype.plugin = /**
     * Returns the plugin settings
     * @return {?}
     */
    function () {
        return Image;
    };
    PluginImage.decorators = [
        { type: Injectable }
    ];
    return PluginImage;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<img>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/image) for API details
 */
var PluginImageModule = /** @class */ (function () {
    function PluginImageModule() {
    }
    PluginImageModule.decorators = [
        { type: NgModule, args: [{
                    providers: [PluginImage]
                },] }
    ];
    return PluginImageModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<a>` block tool for `EditorJS`
 */
var PluginLink = /** @class */ (function () {
    function PluginLink() {
    }
    /**
     * Returns the plugin settings
     */
    /**
     * Returns the plugin settings
     * @return {?}
     */
    PluginLink.prototype.plugin = /**
     * Returns the plugin settings
     * @return {?}
     */
    function () {
        return Link;
    };
    PluginLink.decorators = [
        { type: Injectable }
    ];
    return PluginLink;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<a>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/link) for API details
 */
var PluginLinkModule = /** @class */ (function () {
    function PluginLinkModule() {
    }
    PluginLinkModule.decorators = [
        { type: NgModule, args: [{
                    providers: [PluginLink]
                },] }
    ];
    return PluginLinkModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<li>` and `<ol>` block tool for `EditorJS`
 */
var PluginList = /** @class */ (function () {
    function PluginList() {
    }
    /**
     * Returns the plugin settings
     */
    /**
     * Returns the plugin settings
     * @return {?}
     */
    PluginList.prototype.plugin = /**
     * Returns the plugin settings
     * @return {?}
     */
    function () {
        return List;
    };
    PluginList.decorators = [
        { type: Injectable }
    ];
    return PluginList;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<li>` and `<ol>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/list) for API details
 */
var PluginListModule = /** @class */ (function () {
    function PluginListModule() {
    }
    PluginListModule.decorators = [
        { type: NgModule, args: [{
                    providers: [PluginList]
                },] }
    ];
    return PluginListModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a inline marker tool for `EditorJS`
 */
var PluginMarker = /** @class */ (function () {
    function PluginMarker() {
    }
    /**
     * Returns the plugin settings
     */
    /**
     * Returns the plugin settings
     * @return {?}
     */
    PluginMarker.prototype.plugin = /**
     * Returns the plugin settings
     * @return {?}
     */
    function () {
        return Marker;
    };
    /**
     * Returns the plugin shortcut
     */
    /**
     * Returns the plugin shortcut
     * @return {?}
     */
    PluginMarker.prototype.shortcut = /**
     * Returns the plugin shortcut
     * @return {?}
     */
    function () {
        return 'CMD+SHIFT+M';
    };
    PluginMarker.decorators = [
        { type: Injectable }
    ];
    return PluginMarker;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` inline marker tool.
 * See [the GitHub repo](https://github.com/editor-js/marker) for API details
 */
var PluginMarkerModule = /** @class */ (function () {
    function PluginMarkerModule() {
    }
    PluginMarkerModule.decorators = [
        { type: NgModule, args: [{
                    providers: [PluginMarker]
                },] }
    ];
    return PluginMarkerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the tool settings for a `<p>` block tool for `EditorJS`
 */
var PluginParagraph = /** @class */ (function () {
    function PluginParagraph() {
    }
    /**
     * Returns the plugin settings
     */
    /**
     * Returns the plugin settings
     * @return {?}
     */
    PluginParagraph.prototype.plugin = /**
     * Returns the plugin settings
     * @return {?}
     */
    function () {
        return Paragraph;
    };
    PluginParagraph.decorators = [
        { type: Injectable }
    ];
    return PluginParagraph;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the default `EditorJS` `<p>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
 */
var PluginParagraphModule = /** @class */ (function () {
    function PluginParagraphModule() {
    }
    PluginParagraphModule.decorators = [
        { type: NgModule, args: [{
                    providers: [PluginParagraph]
                },] }
    ];
    return PluginParagraphModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This plugin returns the simple image tool for `<img>` block editor `EditorJS`
 */
var PluginSimpleImage = /** @class */ (function () {
    function PluginSimpleImage() {
    }
    /**
     * Returns the plugin settings
     */
    /**
     * Returns the plugin settings
     * @return {?}
     */
    PluginSimpleImage.prototype.plugin = /**
     * Returns the plugin settings
     * @return {?}
     */
    function () {
        return SimpleImage;
    };
    PluginSimpleImage.decorators = [
        { type: Injectable }
    ];
    return PluginSimpleImage;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * A module that provides the simple image tools for `EditorJS` `<img>` block tool.
 * See [the GitHub repo](https://github.com/editor-js/image) for API details
 */
var PluginSimpleImageModule = /** @class */ (function () {
    function PluginSimpleImageModule() {
    }
    PluginSimpleImageModule.decorators = [
        { type: NgModule, args: [{
                    providers: [PluginSimpleImage]
                },] }
    ];
    return PluginSimpleImageModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * The Injection token for initial plugins as defined in the ngx-editorjs module
 * @type {?}
 */
var InitialPlugins = new InjectionToken('InitialPlugins');
/**
 * The injection token for adding plugins via your own application
 * @type {?}
 */
var UserPlugins = new InjectionToken('UserPlugins');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * The plugin service provides a singleton to store all plugins injected into the application
 * and makes them available for all instances of `EditorJS`
 */
var NgxEditorJSPluginService = /** @class */ (function () {
    /**
     * When the class is initialized the initial plugins and any user plugins
     * will be passed in and merged and stored in the config map
     * @param initialPlugins Default plugins produced by the module
     * @param userPlugins User plugins injected into the application
     */
    function NgxEditorJSPluginService(initialPlugins, userPlugins) {
        var _this = this;
        /**
         * Object map of the plugin configurations
         */
        this.pluginsMap = {};
        Object.entries(__assign({}, initialPlugins, userPlugins)).forEach((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 2), key = _b[0], tool = _b[1];
            return _this.add(key, tool);
        }));
    }
    /**
     * Add a plugin to the store
     * @param key The key for the map to store the plugin
     * @param plugin The plugin instance to add to the service
     */
    /**
     * Add a plugin to the store
     * @param {?} key The key for the map to store the plugin
     * @param {?} plugin The plugin instance to add to the service
     * @return {?}
     */
    NgxEditorJSPluginService.prototype.add = /**
     * Add a plugin to the store
     * @param {?} key The key for the map to store the plugin
     * @param {?} plugin The plugin instance to add to the service
     * @return {?}
     */
    function (key, plugin) {
        this.pluginsMap[key] = plugin;
    };
    /**
     * Remove a plugin from the store
     * @param key
     */
    /**
     * Remove a plugin from the store
     * @param {?} key
     * @return {?}
     */
    NgxEditorJSPluginService.prototype.remove = /**
     * Remove a plugin from the store
     * @param {?} key
     * @return {?}
     */
    function (key) {
        this.pluginsMap[key] = null;
        delete this.pluginsMap[key];
    };
    /**
     * Get a single plugin from the map
     * @param name
     */
    /**
     * Get a single plugin from the map
     * @param {?} key
     * @return {?}
     */
    NgxEditorJSPluginService.prototype.get = /**
     * Get a single plugin from the map
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return this.pluginsMap[key];
    };
    Object.defineProperty(NgxEditorJSPluginService.prototype, "plugins", {
        /**
         * Returns a map of all the plugins registered with this service
         */
        get: /**
         * Returns a map of all the plugins registered with this service
         * @return {?}
         */
        function () {
            return this.pluginsMap;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Returns a map of tools to be initialized by the editor
     * @param exclude Optional array of keys to exclude from the map
     */
    /**
     * Returns a map of tools to be initialized by the editor
     * @param {?=} exclude Optional array of keys to exclude from the map
     * @return {?}
     */
    NgxEditorJSPluginService.prototype.getTools = /**
     * Returns a map of tools to be initialized by the editor
     * @param {?=} exclude Optional array of keys to exclude from the map
     * @return {?}
     */
    function (exclude) {
        if (exclude === void 0) { exclude = []; }
        return Object.entries(this.pluginsMap)
            .filter((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 1), key = _b[0];
            return !exclude.includes(key);
        }))
            .reduce((/**
         * @param {?} finalTools
         * @param {?} __1
         * @return {?}
         */
        function (finalTools, _a) {
            var _b = __read(_a, 2), key = _b[0], plugin = _b[1];
            var _c, _d;
            if (plugin.shortcut) {
                return __assign((_c = {}, _c[key] = {
                    class: plugin.plugin(),
                    shortcut: plugin.shortcut()
                }, _c), finalTools);
            }
            else {
                return __assign((_d = {}, _d[key] = plugin.plugin(), _d), finalTools);
            }
        }), {});
    };
    NgxEditorJSPluginService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxEditorJSPluginService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [InitialPlugins,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [UserPlugins,] }] }
    ]; };
    /** @nocollapse */ NgxEditorJSPluginService.ngInjectableDef = defineInjectable({ factory: function NgxEditorJSPluginService_Factory() { return new NgxEditorJSPluginService(inject(InitialPlugins), inject(UserPlugins, 8)); }, token: NgxEditorJSPluginService, providedIn: "root" });
    return NgxEditorJSPluginService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * This module provides the plugin service used by NgxEditorJS.
 */
var NgxEditorJSPluginServiceModule = /** @class */ (function () {
    function NgxEditorJSPluginServiceModule() {
    }
    NgxEditorJSPluginServiceModule.decorators = [
        { type: NgModule, args: [{
                    providers: [NgxEditorJSPluginService]
                },] }
    ];
    return NgxEditorJSPluginServiceModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * The `NgxEditorjsPluginsModule` provides several additional modules
 * that provide a way to easily plug in block and inline tools for `EditorJS`.
 *
 * Importing `NgxEditorjsPluginsModule` will include all modules, while it
 * is also possible to import each individual module as required.
 */
var NgxEditorjsPluginsModule = /** @class */ (function () {
    function NgxEditorjsPluginsModule() {
    }
    NgxEditorjsPluginsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        PluginCodeModule,
                        PluginHeaderModule,
                        PluginImageModule,
                        PluginLinkModule,
                        PluginListModule,
                        PluginMarkerModule,
                        PluginParagraphModule,
                        PluginSimpleImageModule,
                        NgxEditorJSPluginServiceModule
                    ],
                    exports: [
                        PluginCodeModule,
                        PluginHeaderModule,
                        PluginImageModule,
                        PluginLinkModule,
                        PluginListModule,
                        PluginMarkerModule,
                        PluginParagraphModule,
                        PluginSimpleImageModule,
                        NgxEditorJSPluginServiceModule
                    ]
                },] }
    ];
    return NgxEditorjsPluginsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxEditorjsPluginsModule, PluginCodeModule, PluginCode, PluginHeaderModule, PluginHeader, PluginImageModule, PluginImage, PluginLinkModule, PluginLink, PluginListModule, PluginList, PluginMarkerModule, PluginMarker, PluginParagraphModule, PluginParagraph, PluginSimpleImageModule, PluginSimpleImage, NgxEditorJSPluginService, InitialPlugins, UserPlugins, NgxEditorJSPluginServiceModule as ɵa };

//# sourceMappingURL=tinynodes-ngx-editorjs-plugins.js.map